package com.huimv.guowei.admin.mqtt.back;

import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.Date;

@Component
public
//接收消息回调
class PushCallback implements MqttCallback {


    @Override
    public void connectionLost(Throwable cause) {

        // 连接丢失后，一般在这里面进行重连
        System.out.println("连接断开，可以做重连");
    }

    @Override
    public void deliveryComplete(IMqttDeliveryToken token) {
        System.out.println("deliveryComplete---------" + token.isComplete());
    }

    @Override
    public void messageArrived(String topic, MqttMessage message) throws Exception {
        // subscribe后得到的消息会执行到这里面
        System.out.println("接收消息主题 : " + topic);
        System.out.println("接收消息Qos : " + message.getQos());
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = new Date();
        System.out.println("接收消息的时间：" + sdf.format(date));
        byte[] payload = message.getPayload();
        StringBuilder sb = new StringBuilder();
        for (byte b : payload) {
            sb.append(String.format("%02x", b));
        }
        String s = sb.toString();
        System.out.println("接收消息内容 : " + s);
        System.out.println("开始处理当前数据...");
        System.out.println("数据处理完成！");
    }

}

