package com.huimv.guowei.admin.service.impl;

import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyElectricity;
import com.huimv.guowei.admin.entity.EnergyWater;
import com.huimv.guowei.admin.mapper.EnergyElectricityMapper;
import com.huimv.guowei.admin.service.IEnergyElectricityService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Service
public class EnergyElectricityServiceImpl extends ServiceImpl<EnergyElectricityMapper, EnergyElectricity> implements IEnergyElectricityService {
    @Resource
    private EnergyElectricityMapper energyElectricityMapper;

    @Override
    public Result getElectricity(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        Map resultMap = new HashMap();
        BigDecimal dayElectricity = energyElectricityMapper.getDayElectricity(farmId);
        if (dayElectricity == null){
            dayElectricity = BigDecimal.ZERO;
        }
        BigDecimal monthElectricity = energyElectricityMapper.getMonthElectricity(farmId);
        if (monthElectricity == null){
            monthElectricity = BigDecimal.ZERO;
        }
        resultMap.put("dayElectricity",dayElectricity);
        resultMap.put("MonthElectricity",monthElectricity);
        return new Result(ResultCode.SUCCESS,resultMap);
    }

    @Override
    public Result listElectricity(Map<String, String> paramsMap) {
        String type = paramsMap.get("type");
        String farmId = paramsMap.get("farmId");
        String startDate = paramsMap.get("startDate");
        String endDate = paramsMap.get("endDate")+" 23:59:59";

        List<EnergyElectricity> energyElectricityList = null;
        if ("1".equals(type)){
            energyElectricityList = energyElectricityMapper.listDayDetail(farmId);
        }
        if ("2".equals(type)){
            energyElectricityList = energyElectricityMapper.listWeekDetail(farmId);
        }
        if ("3".equals(type)){
            energyElectricityList = energyElectricityMapper.listMonthDetail(farmId);
        }
        if ("4".equals(type)){
            energyElectricityList = energyElectricityMapper.listCustomDetail(farmId,startDate,endDate);
        }
        return new Result(ResultCode.SUCCESS,energyElectricityList);
    }
}
