package com.huimv.guowei.admin.service.impl;

import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnergyWater;
import com.huimv.guowei.admin.entity.vo.WaterLineVo;
import com.huimv.guowei.admin.mapper.EnergyWaterMapper;
import com.huimv.guowei.admin.service.IEnergyWaterService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@Service
public class EnergyWaterServiceImpl extends ServiceImpl<EnergyWaterMapper, EnergyWater> implements IEnergyWaterService {
    @Resource
    private EnergyWaterMapper energyWaterMapper;

    @Override
    public Result listWater(Map<String, String> paramsMap) {
        String type = paramsMap.get("type");
        String farmId = paramsMap.get("farmId");
        String startDate = paramsMap.get("startDate");
        String endDate = paramsMap.get("endDate")+" 23:59:59";

        List<EnergyWater> energyWaterList = null;
        if ("1".equals(type)){
            energyWaterList = energyWaterMapper.listDayDetail(farmId);
        }
        if ("2".equals(type)){
            energyWaterList = energyWaterMapper.listWeekDetail(farmId);
        }
        if ("3".equals(type)){
            energyWaterList = energyWaterMapper.listMonthDetail(farmId);
        }
        if ("4".equals(type)){
            energyWaterList = energyWaterMapper.listCustomDetail(farmId,startDate,endDate);
        }
        return new Result(ResultCode.SUCCESS,energyWaterList);
    }

    @Override
    public Result getWater(Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        Map resultMap = new HashMap();
        BigDecimal dayWater = energyWaterMapper.getDayWater(farmId);
        if (dayWater == null){
            dayWater = BigDecimal.ZERO;
        }
        BigDecimal monthWater = energyWaterMapper.getMonthWater(farmId);
        if (monthWater == null){
            monthWater = BigDecimal.ZERO;
        }
        resultMap.put("dayWater",dayWater);
        resultMap.put("MonthWater",monthWater);
        return new Result(ResultCode.SUCCESS,resultMap);
    }

    @Override
    //TODO 目前先写死 水线芯片号
    public Result listWaterLine(Map<String, String> paramsMap) {
        String type = paramsMap.get("type");
        String farmId = paramsMap.get("farmId");
        String startDate = paramsMap.get("startDate");
        String endDate = paramsMap.get("endDate")+" 23:59:59";

        List<WaterLineVo> waterLineList = new ArrayList<>();
        if ("1".equals(type)){
            waterLineList = energyWaterMapper.listWaterLineDayDetail(farmId);
        }
        if ("2".equals(type)){
            waterLineList = energyWaterMapper.listWaterLineWeekDetail(farmId);
        }
        if ("3".equals(type)){
            waterLineList = energyWaterMapper.listWaterLineMonthDetail(farmId);
        }
        if ("4".equals(type)){
            waterLineList = energyWaterMapper.listWaterLineCustomDetail(farmId,startDate,endDate);
        }

        return new Result(ResultCode.SUCCESS,waterLineList);
    }
}
